# Connectors

In order to interact with your cloud infrastructure, unSkript has to be able to connect to your cloud tooling.

Connectors securely handle your Cloud credentials without exposing them in the code. Using credentials allows unSkript's RunBooks to interact with your systems. \\

unSkript supports the following Connectors-

* Data services like [Redis](/unskript-documentation/connnecting/connectors/redis.md), [MySQL](/unskript-documentation/connnecting/connectors/mysql.md), [Snowflake](/unskript-documentation/connnecting/connectors/snowflake.md), [MongoDB](/unskript-documentation/connnecting/connectors/mongodb.md), [Kafka](/unskript-documentation/connnecting/connectors/apache-kafka.md), [Postgresql](/unskript-documentation/connnecting/connectors/postgres.md), [Hadoop](/unskript-documentation/connnecting/connectors/hadoop.md), [MSSQL](/unskript-documentation/connnecting/connectors/ms-sql.md), [Splunk](/unskript-documentation/connnecting/connectors/splunk.md)
* Observability services like [Grafana](/unskript-documentation/connnecting/connectors/grafana.md), [Datadog](/unskript-documentation/connnecting/connectors/datadog.md), [Zabbix](/unskript-documentation/connnecting/connectors/zabbix.md), [Pingdom](/unskript-documentation/connnecting/connectors/pingdom.md), [OpenSearch](/unskript-documentation/connnecting/connectors/opensearch.md), [Elasticsearch](/unskript-documentation/connnecting/connectors/elasticsearch.md), [Prometheus](/unskript-documentation/connnecting/connectors/prometheus.md)
* CI/CD platforms such as [Jenkins](/unskript-documentation/connnecting/connectors/jenkins.md), [Jira](/unskript-documentation/connnecting/connectors/jira.md), [GitHub](/unskript-documentation/connnecting/connectors/github.md), [Terraform](/unskript-documentation/connnecting/connectors/terraform.md)
* Infrastructure services such as [AWS](/unskript-documentation/connnecting/connectors/aws.md), [GCP](/unskript-documentation/connnecting/connectors/gcp.md), [K8S](/unskript-documentation/connnecting/connectors/kubernetes.md), [Azure](/unskript-documentation/connnecting/connectors/azure.md)
* Utilities like [Airflow](/unskript-documentation/connnecting/connectors/airflow.md), [Slack](/unskript-documentation/connnecting/connectors/slack.md), [Stripe](/unskript-documentation/connnecting/connectors/stripe.md)
* Any API or application with a [REST API](/unskript-documentation/connnecting/connectors/rest.md) or [SSH](/unskript-documentation/connnecting/connectors/ssh.md) connectivity

The full list can be seen in the left navigation, and the links point to set up instructions to establish your connection.

### Credentials

Credential types vary depending on the Authentication pathways provided by the connector: API tokens, keys & secrets, JSON config files. etc. Each Connector page has details on how to add your credentials for that platform.

There may be times where there are multiple credentials to one Connector (Some xRunBooks or Actions may require different permissions, and using the [principles of least privilege](https://unskript.com/blog/automate-the-creation-of-least-privileged-aws-security-profiles), it may be better to have different credentials.

### Credentials as a Variable

To reuse an xRunBook across multiple environments, the credential can be set as a serviceID. This of a serviceID as a variable. In each unSkript environment, assign a credential to the serviceID. When the xRunBook is run in an environment - the credential with that serviceID is used to run the Actions.

For example, if there are 2 environments: *dev* and *production,* each with different AWS credentials. If the credentials in dev and production have the same serviceID, each Action in a RunBook can use the serviceId variable for authentication. A new Runbook input parameter "environment" is added. Specifying "Dev" will use the dev credentials, while using "production will use the production serviceID credentials.

Head to the section on [environments](/unskript-documentation/connnecting/proxies/connect-your-environment.md) to learn more.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.unskript.com/unskript-documentation/connnecting/connectors.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
